/*!
WordPress plugin gravityforms-cnp
Recurring Payments field
*/

// initialise form on page load
jQuery(function($) {

	var	thisYear = (new Date()).getFullYear(),
		yearRange = thisYear + ":2099",				// year range for max date settings, mumble mumble jquery-ui mumble
		reDatePattern = /^\d{4}-\d\d-\d\d$/,		// regex test for ISO date string
		setPickerOptions = false;

	// set datepicker minimum date if given
	$("input[data-gfcnp-minDate]").each(function() {
		var	input = $(this),
			minDate = this.getAttribute("data-gfcnp-minDate");

		// if minDate is an ISO date string, convert to a Date object as a reliable way to set minDate
		if (reDatePattern.test(minDate)) {
			minDate = new Date(minDate);
		}

		input.datepicker("option", "minDate", minDate);
		setPickerOptions = true;
	});

	// set datepicker maximum date if given
	$("input[data-gfcnp-maxDate]").each(function() {
		var	input = $(this),
			maxDate = this.getAttribute("data-gfcnp-maxDate");

		// if maxDate is an ISO date string, convert to a Date object as a reliable way to set maxDate
		if (reDatePattern.test(maxDate)) {
			maxDate = new Date(maxDate);
		}

		input.datepicker("option", "yearRange", yearRange);		// need to reset year range so can extend max date!
		input.datepicker("option", "maxDate", maxDate);
		setPickerOptions = true;
	});

	// hack: setting options on datepicker fields after initialisation makes the datepicker div show at the bottom of the page
	if (setPickerOptions) {
		$("#ui-datepicker-div").hide();
	}
	
});
function manageshowhideRecpay(cnpfldval,cnpfldid,cnpfrmid) { 

var selValue = cnpfldval.value;

var rectypcnp = "tr.dvrecurtyp-"+cnpfrmid;
var perdctycnp = "tr.dvperdcty-"+cnpfrmid;
var dvnoofpymnts = "tr.dvnoofpymnts-"+cnpfrmid;
var result = cnpfldid.split('gfcnp_rctyp_');

var cnpalrtmsg = "#validation_message_"+cnpfrmid+"_"+result[1];

if (typeof selValue === "undefined") {
	selValue = cnpfldval;
}

						if( selValue == 'One Time Only') {	
							jQuery(perdctycnp).hide();
							jQuery(rectypcnp).hide();
							jQuery(dvnoofpymnts).hide();
							jQuery('.gfprctyp').val('no');
							jQuery(cnpalrtmsg).hide();
							
							
						} else {	
							jQuery(perdctycnp).show();
							jQuery(rectypcnp).show();	
							jQuery(dvnoofpymnts).show();
							jQuery('.gfprctyp').val('yes');
							jQuery(cnpalrtmsg).show();
							
							}
							manageRecpay(cnpfldid);
	}
						
				function manageRecpay() { 
					
						if(jQuery('.recpayoptions:checked').val() == 'Recurring') {
						
						 if(jQuery('.RecurringMethodSelect').length > 0) { 
						
						  if(jQuery('.RecurringMethodSelect').val().substr(-11) == 'Installment' && jQuery('#gfpnopaymntstyp').val() == 'indefinite_openfield') {
								 
						if(jQuery('.txtinputval').val() != '' && jQuery('.txtinputval').val() <= 998){jQuery('.txtinputval').val(jQuery('.txtinputval').val());}else{jQuery('.txtinputval').val('998');}
							
							} 
							if(jQuery('.RecurringMethodSelect').val().substr(-12) == 'Subscription' && jQuery('#gfpnopaymntstyp').val() == 'indefinite_openfield') {
								if(jQuery('.txtinputval').val() != ''){jQuery('.txtinputval').val(jQuery('.txtinputval').val());}else{jQuery('.txtinputval').val('999');}			
							} 
						}
					}
}
